Index: TOOLS/WATER_BUDGET/ATM_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6446)
+++ TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6508)
@@ -715,30 +812,31 @@
     RUN_mas_wat_slow_beg   = ONE_stock_int ( d_RUN_beg ['slow_reservoir']   )
     RUN_mas_wat_stream_beg = ONE_stock_int ( d_RUN_beg ['stream_reservoir'] )
-    RUN_mas_wat_flood_beg  = 0.0
-    RUN_mas_wat_lake_beg   = 0.0
-    RUN_mas_wat_pond_beg   = 0.0
+    
+    RUN_mas_wat_flood_beg  = ONE_stock_int ( d_SRF_beg ['floodres']  )
+    RUN_mas_wat_lake_beg   = ONE_stock_int ( d_SRF_beg ['lakeres']   )
+    RUN_mas_wat_pond_beg   = ONE_stock_int ( d_SRF_beg ['pondres']   )
     
     RUN_mas_wat_fast_end   = ONE_stock_int ( d_RUN_end ['fast_reservoir']   )
     RUN_mas_wat_slow_end   = ONE_stock_int ( d_RUN_end ['slow_reservoir']   )
     RUN_mas_wat_stream_end = ONE_stock_int ( d_RUN_end ['stream_reservoir'] )
-    RUN_mas_wat_flood_end  = 0.0
-    RUN_mas_wat_lake_end   = 0.0
-    RUN_mas_wat_pond_end   = 0.0
-
-if Routing == 'SECHIBA' :
-    RUN_mas_wat_fast_beg   = ONE_stock_int ( d_SRF_beg ['fastres']   )
-    RUN_mas_wat_slow_beg   = ONE_stock_int ( d_SRF_beg ['slowres']   )
-    RUN_mas_wat_stream_beg = ONE_stock_int ( d_SRF_beg ['streamres'] )
-    RUN_mas_wat_flood_beg  = ONE_stock_int ( d_SRF_beg ['floodres']  )
-    RUN_mas_wat_lake_beg   = ONE_stock_int ( d_SRF_beg ['lakeres']   )
-    RUN_mas_wat_pond_beg   = ONE_stock_int ( d_SRF_beg ['pondres']   )
-
-    
-    RUN_mas_wat_fast_end   = ONE_stock_int ( d_SRF_end ['fastres']   )
-    RUN_mas_wat_slow_end   = ONE_stock_int ( d_SRF_end ['slowres']   )
-    RUN_mas_wat_stream_end = ONE_stock_int ( d_SRF_end ['streamres'] )
+    
     RUN_mas_wat_flood_end  = ONE_stock_int ( d_SRF_end ['floodres']  )
     RUN_mas_wat_lake_end   = ONE_stock_int ( d_SRF_end ['lakeres']   )
     RUN_mas_wat_pond_end   = ONE_stock_int ( d_SRF_end ['pondres']   )
+
+if Routing == 'SECHIBA' :
+        RUN_mas_wat_fast_beg   = ONE_stock_int ( d_SRF_beg ['fastres']   )
+        RUN_mas_wat_slow_beg   = ONE_stock_int ( d_SRF_beg ['slowres']   )
+        RUN_mas_wat_stream_beg = ONE_stock_int ( d_SRF_beg ['streamres'] )
+        RUN_mas_wat_flood_beg  = ONE_stock_int ( d_SRF_beg ['floodres']  )
+        RUN_mas_wat_lake_beg   = ONE_stock_int ( d_SRF_beg ['lakeres']   )
+        RUN_mas_wat_pond_beg   = ONE_stock_int ( d_SRF_beg ['pondres']   )
+        
+        RUN_mas_wat_fast_end   = ONE_stock_int ( d_SRF_end ['fastres']   )
+        RUN_mas_wat_slow_end   = ONE_stock_int ( d_SRF_end ['slowres']   )
+        RUN_mas_wat_stream_end = ONE_stock_int ( d_SRF_end ['streamres'] )
+        RUN_mas_wat_flood_end  = ONE_stock_int ( d_SRF_end ['floodres']  )
+        RUN_mas_wat_lake_end   = ONE_stock_int ( d_SRF_end ['lakeres']   )
+        RUN_mas_wat_pond_end   = ONE_stock_int ( d_SRF_end ['pondres']   )
 
 RUN_mas_wat_beg = RUN_mas_wat_fast_beg + RUN_mas_wat_slow_beg + RUN_mas_wat_stream_beg + RUN_mas_wat_flood_beg + RUN_mas_wat_lake_beg + RUN_mas_wat_pond_beg
@@ -754,12 +852,13 @@
 dRUN_mas_wat        = RUN_mas_wat_end        - RUN_mas_wat_beg
 
-echo ( f'\nLes differents reservoirs  -- {Title} ')
-echo ( '------------------------------------------------------------------------------------' )
-echo ( 'RUN_mas_wat_fast_beg   = {:12.6e} kg | RUN_mas_wat_fast_end   = {:12.6e} kg '.format (RUN_mas_wat_fast_beg  , RUN_mas_wat_fast_end   ) )
-echo ( 'RUN_mas_wat_slow_beg   = {:12.6e} kg | RUN_mas_wat_slow_end   = {:12.6e} kg '.format (RUN_mas_wat_slow_beg  , RUN_mas_wat_slow_end   ) )
-echo ( 'RUN_mas_wat_stream_beg = {:12.6e} kg | RUN_mas_wat_stream_end = {:12.6e} kg '.format (RUN_mas_wat_stream_beg, RUN_mas_wat_stream_end ) )
-echo ( 'RUN_mas_wat_flood_beg  = {:12.6e} kg | RUN_mas_wat_flood_end  = {:12.6e} kg '.format (RUN_mas_wat_flood_beg , RUN_mas_wat_flood_end  ) )
-echo ( 'RUN_mas_wat_lake_beg   = {:12.6e} kg | RUN_mas_wat_lake_end   = {:12.6e} kg '.format (RUN_mas_wat_lake_beg  , RUN_mas_wat_lake_end   ) )
-echo ( 'RUN_mas_wat_pond_beg   = {:12.6e} kg | RUN_mas_wat_pond_end   = {:12.6e} kg '.format (RUN_mas_wat_pond_beg  , RUN_mas_wat_pond_end   ) )
+echo ( f'\nRunoff reservoirs -- {Title} ')
+echo ( f'------------------------------------------------------------------------------------' )
+echo ( f'RUN_mas_wat_fast_beg   = {RUN_mas_wat_fast_beg  :12.6e} kg | RUN_mas_wat_fast_end   = {RUN_mas_wat_fast_end  :12.6e} kg ' )
+echo ( f'RUN_mas_wat_slow_beg   = {RUN_mas_wat_slow_beg  :12.6e} kg | RUN_mas_wat_slow_end   = {RUN_mas_wat_slow_end  :12.6e} kg ' )
+echo ( f'RUN_mas_wat_stream_beg = {RUN_mas_wat_stream_beg:12.6e} kg | RUN_mas_wat_stream_end = {RUN_mas_wat_stream_end:12.6e} kg ' )
+echo ( f'RUN_mas_wat_flood_beg  = {RUN_mas_wat_flood_beg :12.6e} kg | RUN_mas_wat_flood_end  = {RUN_mas_wat_flood_end :12.6e} kg ' )
+echo ( f'RUN_mas_wat_lake_beg   = {RUN_mas_wat_lake_beg  :12.6e} kg | RUN_mas_wat_lake_end   = {RUN_mas_wat_lake_end  :12.6e} kg ' )
+echo ( f'RUN_mas_wat_pond_beg   = {RUN_mas_wat_pond_beg  :12.6e} kg | RUN_mas_wat_pond_end   = {RUN_mas_wat_pond_end  :12.6e} kg ' )
+echo ( f'RUN_mas_wat_beg        = {RUN_mas_wat_beg       :12.6e} kg | RUN_mas_wat_end        = {RUN_mas_wat_end       :12.6e} kg ' )
 
 echo ( '------------------------------------------------------------------------------------' )
@@ -776,37 +875,37 @@
 echo ( '------------------------------------------------------------------------------------' )
 echo ( 'RUN_mas_wat_beg = {:12.6e} kg | RUN_mas_wat_end = {:12.6e} kg '.format (RUN_mas_wat_end, RUN_mas_wat_end) )
-prtFlux ( 'dMass (routing) ', dRUN_mas_wat       )
+prtFlux ( 'dMass (routing) ', dRUN_mas_wat , 'e', True   )
 
 echo ( '\n====================================================================================' )
 print (f'Reading SRF restart')
-SRF_tot_watveg_beg  = d_SRF_beg['tot_watveg_beg']  ; SRF_tot_watveg_beg  = SRF_tot_watveg_beg .where (SRF_tot_watveg_beg < 1E15, 0.)
-SRF_tot_watsoil_beg = d_SRF_beg['tot_watsoil_beg'] ; SRF_tot_watsoil_beg = SRF_tot_watsoil_beg.where (SRF_tot_watsoil_beg< 1E15, 0.)
-SRF_snow_beg        = d_SRF_beg['snow_beg']        ; SRF_snow_beg        = SRF_snow_beg       .where (SRF_snow_beg       < 1E15, 0.)
-SRF_lakeres_beg     = d_SRF_beg['lakeres']         ; SRF_lakeres_beg     = SRF_lakeres_beg    .where (SRF_lakeres_beg    < 1E15, 0.)
-
-SRF_tot_watveg_end  = d_SRF_end['tot_watveg_beg']  ; SRF_tot_watveg_end  = SRF_tot_watveg_end .where (SRF_tot_watveg_end < 1E15, 0.)
-SRF_tot_watsoil_end = d_SRF_end['tot_watsoil_beg'] ; SRF_tot_watsoil_end = SRF_tot_watsoil_end.where (SRF_tot_watsoil_end< 1E15, 0.)
-SRF_snow_end        = d_SRF_end['snow_beg']        ; SRF_snow_end        = SRF_snow_end       .where (SRF_snow_end       < 1E15, 0.)
-SRF_lakeres_end     = d_SRF_end['lakeres']         ; SRF_lakeres_end     = SRF_lakeres_end    .where (SRF_lakeres_end    < 1E15, 0.)
+SRF_tot_watveg_beg  = d_SRF_beg['tot_watveg_beg']  ; SRF_tot_watveg_beg  = SRF_tot_watveg_beg .where (SRF_tot_watveg_beg  < 1E15, 0.)
+SRF_tot_watsoil_beg = d_SRF_beg['tot_watsoil_beg'] ; SRF_tot_watsoil_beg = SRF_tot_watsoil_beg.where (SRF_tot_watsoil_beg < 1E15, 0.)
+SRF_snow_beg        = d_SRF_beg['snow_beg']        ; SRF_snow_beg        = SRF_snow_beg       .where (SRF_snow_beg        < 1E15, 0.)
+SRF_lakeres_beg     = d_SRF_beg['lakeres']         ; SRF_lakeres_beg     = SRF_lakeres_beg    .where (SRF_lakeres_beg     < 1E15, 0.)
+
+SRF_tot_watveg_end  = d_SRF_end['tot_watveg_beg']  ; SRF_tot_watveg_end  = SRF_tot_watveg_end .where (SRF_tot_watveg_end  < 1E15, 0.)
+SRF_tot_watsoil_end = d_SRF_end['tot_watsoil_beg'] ; SRF_tot_watsoil_end = SRF_tot_watsoil_end.where (SRF_tot_watsoil_end < 1E15, 0.)
+SRF_snow_end        = d_SRF_end['snow_beg']        ; SRF_snow_end        = SRF_snow_end       .where (SRF_snow_end        < 1E15, 0.)
+SRF_lakeres_end     = d_SRF_end['lakeres']         ; SRF_lakeres_end     = SRF_lakeres_end    .where (SRF_lakeres_end     < 1E15, 0.)
 
 if LMDZ :
-    SRF_tot_watveg_beg  = lmdz.geo2point (SRF_tot_watveg_beg )
-    SRF_tot_watsoil_beg = lmdz.geo2point (SRF_tot_watsoil_beg)
-    SRF_snow_beg        = lmdz.geo2point (SRF_snow_beg       )
-    SRF_lakeres_beg     = lmdz.geo2point (SRF_lakeres_beg    )
-    SRF_tot_watveg_end  = lmdz.geo2point (SRF_tot_watveg_end )
-    SRF_tot_watsoil_end = lmdz.geo2point (SRF_tot_watsoil_end)
-    SRF_snow_end        = lmdz.geo2point (SRF_snow_end       )
-    SRF_lakeres_end     = lmdz.geo2point (SRF_lakeres_end    )
+    SRF_tot_watveg_beg  = lmdz.geo2point (SRF_tot_watveg_beg , dim1D='cell')
+    SRF_tot_watsoil_beg = lmdz.geo2point (SRF_tot_watsoil_beg, dim1D='cell')
+    SRF_snow_beg        = lmdz.geo2point (SRF_snow_beg       , dim1D='cell')
+    SRF_lakeres_beg     = lmdz.geo2point (SRF_lakeres_beg    , dim1D='cell')
+    SRF_tot_watveg_end  = lmdz.geo2point (SRF_tot_watveg_end , dim1D='cell')
+    SRF_tot_watsoil_end = lmdz.geo2point (SRF_tot_watsoil_end, dim1D='cell')
+    SRF_snow_end        = lmdz.geo2point (SRF_snow_end       , dim1D='cell')
+    SRF_lakeres_end     = lmdz.geo2point (SRF_lakeres_end    , dim1D='cell')
   
 if ICO :
-    SRF_tot_watveg_beg  = SRF_tot_watveg_beg .rename ( {'y':'cell_mesh'} )
-    SRF_tot_watsoil_beg = SRF_tot_watsoil_beg.rename ( {'y':'cell_mesh'} )
-    SRF_snow_beg        = SRF_snow_beg       .rename ( {'y':'cell_mesh'} )
-    SRF_lakeres_beg     = SRF_lakeres_beg    .rename ( {'y':'cell_mesh'} )
-    SRF_tot_watveg_end  = SRF_tot_watveg_end .rename ( {'y':'cell_mesh'} )
-    SRF_tot_watsoil_end = SRF_tot_watsoil_end.rename ( {'y':'cell_mesh'} )
-    SRF_snow_end        = SRF_snow_end       .rename ( {'y':'cell_mesh'} )
-    SRF_lakeres_end     = SRF_lakeres_end    .rename ( {'y':'cell_mesh'} )
+    SRF_tot_watveg_beg  = SRF_tot_watveg_beg  [SRF_beg_keysort]
+    SRF_tot_watsoil_beg = SRF_tot_watsoil_beg [SRF_beg_keysort]
+    SRF_snow_beg        = SRF_snow_beg        [SRF_beg_keysort]
+    SRF_lakeres_beg     = SRF_lakeres_beg     [SRF_beg_keysort]
+    SRF_tot_watveg_end  = SRF_tot_watveg_end  [SRF_end_keysort]
+    SRF_tot_watsoil_end = SRF_tot_watsoil_end [SRF_end_keysort]
+    SRF_snow_end        = SRF_snow_end        [SRF_end_keysort]
+    SRF_lakeres_end     = SRF_lakeres_end     [SRF_end_keysort]
 
 # Stock dSoilHum dInterce dSWE dStream dFastR dSlowR dLake dPond dFlood
@@ -844,11 +943,10 @@
 
 
-
 echo ( '------------------------------------------------------------------------------------' )
-echo ( f'\nLes differents reservoirs  -- {Title} ')
-echo ( 'SRF_mas_watveg_beg   = {:12.6e} kg | SRF_mas_watveg_end   = {:12.6e} kg '.format (SRF_mas_watveg_beg  , SRF_mas_watveg_end   ) )
-echo ( 'SRF_mas_watsoil_beg  = {:12.6e} kg | SRF_mas_watsoil_end  = {:12.6e} kg '.format (SRF_mas_watsoil_beg , SRF_mas_watsoil_end  ) )
-echo ( 'SRF_mas_snow_beg     = {:12.6e} kg | SRF_mas_snow_end     = {:12.6e} kg '.format (SRF_mas_snow_beg    , SRF_mas_snow_end     ) )
-echo ( 'SRF_mas_lake_beg     = {:12.6e} kg | SRF_mas_lake_end     = {:12.6e} kg '.format (SRF_mas_lake_beg    , SRF_mas_lake_end     ) )
+echo ( f'\nSurface reservoirs  -- {Title} ')
+echo ( f'SRF_mas_watveg_beg   = {SRF_mas_watveg_beg :12.6e} kg | SRF_mas_watveg_end   = {SRF_mas_watveg_end :12.6e} kg ' )
+echo ( f'SRF_mas_watsoil_beg  = {SRF_mas_watsoil_beg:12.6e} kg | SRF_mas_watsoil_end  = {SRF_mas_watsoil_end:12.6e} kg ' )
+echo ( f'SRF_mas_snow_beg     = {SRF_mas_snow_beg   :12.6e} kg | SRF_mas_snow_end     = {SRF_mas_snow_end   :12.6e} kg ' )
+echo ( f'SRF_mas_lake_beg     = {SRF_mas_lake_beg   :12.6e} kg | SRF_mas_lake_end     = {SRF_mas_lake_end   :12.6e} kg ' )
 
 prtFlux ('dMass (watveg) ', dSRF_mas_watveg , 'e' , True)
@@ -863,5 +961,5 @@
 echo ( '------------------------------------------------------------------------------------' )
 echo ( f'Water content in surface  -- {Title} ' )
-echo ( 'SRF_mas_wat_beg   = {:12.6e} kg | SRF_mas_wat_end  = {:12.6e} kg '.format (SRF_mas_wat_beg, SRF_mas_wat_end) )
+echo ( f'SRF_mas_wat_beg   = {SRF_mas_wat_beg:12.6e} kg | SRF_mas_wat_end  = {SRF_mas_wat_end:12.6e} kg ')
 prtFlux ( 'dMass (water srf)', dSRF_mas_wat, 'e', True )
 
@@ -876,42 +974,105 @@
 echo ( f'-- ATM Fluxes  -- {Title} ' )
 
-ATM_wbilo_oce   = lmdz.geo2point ( d_ATM_his ['wbilo_oce']   )
-ATM_wbilo_sic   = lmdz.geo2point ( d_ATM_his ['wbilo_sic']   )
-ATM_wbilo_ter   = lmdz.geo2point ( d_ATM_his ['wbilo_ter']   )
-ATM_wbilo_lic   = lmdz.geo2point ( d_ATM_his ['wbilo_lic']   )
-ATM_runofflic   = lmdz.geo2point ( d_ATM_his ['runofflic']   )
-ATM_fqcalving   = lmdz.geo2point ( d_ATM_his ['fqcalving']   )
-ATM_fqfonte     = lmdz.geo2point ( d_ATM_his ['fqfonte']     )
-ATM_precip      = lmdz.geo2point ( d_ATM_his ['precip']      )
-ATM_snowf       = lmdz.geo2point ( d_ATM_his ['snow']        )
-ATM_evap        = lmdz.geo2point ( d_ATM_his ['evap']        )
+print ( 'Step 1', end='' )
+if ATM_HIS == 'latlon' :
+    ATM_wbilo_oce   = lmdz.geo2point ( d_ATM_his ['wbilo_oce'], dim1D='cell' )
+    ATM_wbilo_sic   = lmdz.geo2point ( d_ATM_his ['wbilo_sic'], dim1D='cell' )
+    ATM_wbilo_ter   = lmdz.geo2point ( d_ATM_his ['wbilo_ter'], dim1D='cell' )
+    ATM_wbilo_lic   = lmdz.geo2point ( d_ATM_his ['wbilo_lic'], dim1D='cell' )
+    ATM_runofflic   = lmdz.geo2point ( d_ATM_his ['runofflic'], dim1D='cell' )
+    ATM_fqcalving   = lmdz.geo2point ( d_ATM_his ['fqcalving'], dim1D='cell' )
+    ATM_fqfonte     = lmdz.geo2point ( d_ATM_his ['fqfonte']  , dim1D='cell' )
+    ATM_precip      = lmdz.geo2point ( d_ATM_his ['precip']   , dim1D='cell' )
+    ATM_snowf       = lmdz.geo2point ( d_ATM_his ['snow']     , dim1D='cell' )
+    ATM_evap        = lmdz.geo2point ( d_ATM_his ['evap']     , dim1D='cell' )
+    ATM_wevap_ter   = lmdz.geo2point ( d_ATM_his ['wevap_ter'], dim1D='cell' )
+    ATM_wevap_oce   = lmdz.geo2point ( d_ATM_his ['wevap_oce'], dim1D='cell' )
+    ATM_wevap_lic   = lmdz.geo2point ( d_ATM_his ['wevap_lic'], dim1D='cell' )
+    ATM_wevap_sic   = lmdz.geo2point ( d_ATM_his ['wevap_sic'], dim1D='cell' )
+    ATM_runofflic   = lmdz.geo2point ( d_ATM_his ['runofflic'], dim1D='cell' )
+    
+print ( ' - Step 2', end='' )
+if ATM_HIS == 'ico' :
+    ATM_wbilo_oce   = d_ATM_his ['wbilo_oce'][..., ATM_his_keysort]
+    ATM_wbilo_sic   = d_ATM_his ['wbilo_sic'][..., ATM_his_keysort]
+    ATM_wbilo_ter   = d_ATM_his ['wbilo_ter'][..., ATM_his_keysort]
+    ATM_wbilo_lic   = d_ATM_his ['wbilo_lic'][..., ATM_his_keysort]
+    ATM_runofflic   = d_ATM_his ['runofflic'][..., ATM_his_keysort]
+    ATM_fqcalving   = d_ATM_his ['fqcalving'][..., ATM_his_keysort]
+    ATM_fqfonte     = d_ATM_his ['fqfonte']  [..., ATM_his_keysort]
+    ATM_precip      = d_ATM_his ['precip']   [..., ATM_his_keysort]
+    ATM_snowf       = d_ATM_his ['snow']     [..., ATM_his_keysort]
+    ATM_evap        = d_ATM_his ['evap']     [..., ATM_his_keysort]
+    ATM_wevap_ter   = d_ATM_his ['wevap_ter'][..., ATM_his_keysort]
+    ATM_wevap_oce   = d_ATM_his ['wevap_oce'][..., ATM_his_keysort]
+    ATM_wevap_lic   = d_ATM_his ['wevap_lic'][..., ATM_his_keysort]
+    ATM_wevap_sic   = d_ATM_his ['wevap_sic'][..., ATM_his_keysort]
+    ATM_runofflic   = d_ATM_his ['runofflic'][..., ATM_his_keysort]
+
+print ( ' - Step 3', end='' )
 ATM_wbilo       = ATM_wbilo_oce + ATM_wbilo_sic + ATM_wbilo_ter + ATM_wbilo_lic
 ATM_emp         = ATM_evap - ATM_precip
-
-RUN_coastalflow = lmdz.geo2point ( d_RUN_his ['coastalflow'] ) 
-RUN_riverflow   = lmdz.geo2point ( d_RUN_his ['riverflow']   )
-RUN_runoff      = lmdz.geo2point ( d_RUN_his ['runoff']      )
-RUN_drainage    = lmdz.geo2point ( d_RUN_his ['drainage']    )
-RUN_riversret   = lmdz.geo2point ( d_RUN_his ['riversret']   )
-
-RUN_coastalflow_cpl = lmdz.geo2point ( d_RUN_his ['coastalflow_cpl'] ) 
-RUN_riverflow_cpl   = lmdz.geo2point ( d_RUN_his ['riverflow_cpl']   )
-
-SRF_rain     = lmdz.geo2point ( d_SRF_his ['rain']  )
-SRF_evap     = lmdz.geo2point ( d_SRF_his ['evap']  )
-SRF_snowf    = lmdz.geo2point ( d_SRF_his ['snowf'] )
-SRF_subli    = lmdz.geo2point ( d_SRF_his ['subli'] )
-SRF_transpir = lmdz.geo2point ( np.sum(d_SRF_his ['transpir'], axis=1) ) ; SRF_transpir.attrs['units'] = d_SRF_his ['transpir'].attrs['units']
+ATM_wbilo_sea   = ATM_wbilo_oce + ATM_wbilo_sic
+ATM_wevap_sea   = ATM_wevap_sic + ATM_wevap_oce
+
+ATM_wemp_ter = ATM_wevap_ter - ATM_precip * ATM_fter
+ATM_wemp_oce = ATM_wevap_oce - ATM_precip * ATM_foce
+ATM_wemp_sic = ATM_wevap_sic - ATM_precip * ATM_fsic
+ATM_wemp_lic = ATM_wevap_lic - ATM_precip * ATM_flic
+ATM_wemp_sea = ATM_wevap_sic + ATM_wevap_oce - ATM_precip * ATM_fsea
+
+print ( ' - Step 4', end='' )
+if RUN_HIS == 'latlon' : 
+    RUN_coastalflow = lmdz.geo2point ( d_RUN_his ['coastalflow'], dim1D='cell' ) 
+    RUN_riverflow   = lmdz.geo2point ( d_RUN_his ['riverflow']  , dim1D='cell' )
+    RUN_runoff      = lmdz.geo2point ( d_RUN_his ['runoff']     , dim1D='cell' )
+    RUN_drainage    = lmdz.geo2point ( d_RUN_his ['drainage']   , dim1D='cell' )
+    RUN_riversret   = lmdz.geo2point ( d_RUN_his ['riversret']  , dim1D='cell' )
+    
+    RUN_coastalflow_cpl = lmdz.geo2point ( d_RUN_his ['coastalflow_cpl'], dim1D='cell' ) 
+    RUN_riverflow_cpl   = lmdz.geo2point ( d_RUN_his ['riverflow_cpl']  , dim1D='cell' )
+
+print ( ' - Step 5', end='' )
+if RUN_HIS == 'ico' :
+    RUN_coastalflow =  d_RUN_his ['coastalflow'][..., RUN_his_keysort]
+    RUN_riverflow   =  d_RUN_his ['riverflow']  [..., RUN_his_keysort]
+    RUN_runoff      =  d_RUN_his ['runoff']     [..., RUN_his_keysort]
+    RUN_drainage    =  d_RUN_his ['drainage']   [..., RUN_his_keysort]
+    RUN_riversret   =  d_RUN_his ['riversret']  [..., RUN_his_keysort]
+    
+    RUN_coastalflow_cpl = d_RUN_his ['coastalflow_cpl'][..., RUN_his_keysort]
+    RUN_riverflow_cpl   = d_RUN_his ['riverflow_cpl']  [..., RUN_his_keysort]
+
+print ( ' - Step 6', end='' )
+if SRF_HIS == 'latlon' :
+    SRF_rain     = lmdz.geo2point ( d_SRF_his ['rain']  , dim1D='cell')
+    SRF_evap     = lmdz.geo2point ( d_SRF_his ['evap']  , dim1D='cell')
+    SRF_snowf    = lmdz.geo2point ( d_SRF_his ['snowf'] , dim1D='cell')
+    SRF_subli    = lmdz.geo2point ( d_SRF_his ['subli'] , dim1D='cell')
+    SRF_transpir = lmdz.geo2point ( np.sum (d_SRF_his ['transpir'], axis=1), dim1D='cell' )
+
+print ( '- Step 7', end='' )
+if SRF_HIS == 'ico' :
+    SRF_rain     = d_SRF_his ['rain'] [..., SRF_his_keysort]
+    SRF_evap     = d_SRF_his ['evap'] [..., SRF_his_keysort]
+    SRF_snowf    = d_SRF_his ['snowf'][..., SRF_his_keysort]
+    SRF_subli    = d_SRF_his ['subli'][..., SRF_his_keysort]
+    SRF_transpir = np.sum (d_SRF_his ['transpir'], axis=1)[..., SRF_his_keysort]
+
+print ( '- Step 8', end='' )
+SRF_transpir.attrs['units'] = d_SRF_his ['transpir'].attrs['units']
 SRF_emp      = SRF_evap - SRF_rain - SRF_snowf ; SRF_emp.attrs['units'] = SRF_rain.attrs['units']
-
+    
 ## Correcting units of SECHIBA variables
 def mmd2SI ( Var ) :
     '''Change unit from mm/d or m^3/s to kg/s if needed'''
     if 'units' in VarT.attrs : 
-        if VarT.attrs['units'] in ['m^3/s', 'm3/s', 'm3.s-3'] :
+        if VarT.attrs['units'] in ['m^3/s', 'm3/s', 'm3.s-1',] :
             VarT.values = VarT.values  * ATM_rho                 ;  VarT.attrs['units'] = 'kg/s'
         if VarT.attrs['units'] == 'mm/d' :
             VarT.values = VarT.values  * ATM_rho * (1e-3/86400.) ;  VarT.attrs['units'] = 'kg/s'
-
+        if VarT.attrs['units'] in ['m^3', 'm3', ] :
+            VarT.values = VarT.values  * ATM_rho                 ;  VarT.attrs['units'] = 'kg'
+            
 for var in [ 'runoff', 'drainage', 'riversret', 'coastalflow', 'riverflow', 'coastalflow_cpl', 'riverflow_cpl' ] :
     VarT = locals()['RUN_' + var]
@@ -922,17 +1083,19 @@
     mmd2SI (VarT)
 
-
+print ( '- Step 9', end='' )
 RUN_input  = RUN_runoff      + RUN_drainage
 RUN_output = RUN_coastalflow + RUN_riverflow
 
-ATM_wbilo_sea = ATM_wbilo_oce + ATM_wbilo_sic
-
-ATM_flx_oce         = ATM_flux_int ( ATM_wbilo_oce  )
-ATM_flx_sic         = ATM_flux_int ( ATM_wbilo_sic  )
-ATM_flx_sea         = ATM_flux_int ( ATM_wbilo_sea  )
-ATM_flx_ter         = ATM_flux_int ( ATM_wbilo_ter  )
-ATM_flx_lic         = ATM_flux_int ( ATM_wbilo_lic  )
+print ( '- Step 10', end='' )
+ATM_flx_wbilo       = ATM_flux_int ( ATM_wbilo      )
+ATM_flx_wbilo_oce   = ATM_flux_int ( ATM_wbilo_oce  )
+ATM_flx_wbilo_sic   = ATM_flux_int ( ATM_wbilo_sic  )
+ATM_flx_wbilo_sea   = ATM_flux_int ( ATM_wbilo_sea  )
+ATM_flx_wbilo_ter   = ATM_flux_int ( ATM_wbilo_ter  )
+ATM_flx_wbilo_lic   = ATM_flux_int ( ATM_wbilo_lic  )
 ATM_flx_calving     = ATM_flux_int ( ATM_fqcalving  )
-ATM_flx_qfonte      = ATM_flux_int ( ATM_fqfonte    )
+ATM_flx_fqfonte     = ATM_flux_int ( ATM_fqfonte    )
+
+print ( '- Step 11', end='' )
 ATM_flx_precip      = ATM_flux_int ( ATM_precip     )
 ATM_flx_snowf       = ATM_flux_int ( ATM_snowf      )
@@ -940,4 +1103,16 @@
 ATM_flx_runlic      = ATM_flux_int ( ATM_runofflic  )
 
+print ( '- Step 12', end='' )
+ATM_flx_wevap_ter   = ATM_flux_int ( ATM_wevap_ter )
+ATM_flx_wevap_sea   = ATM_flux_int ( ATM_wevap_sea )
+ATM_flx_precip_ter  = ATM_flux_int ( ATM_precip * ATM_fter )
+ATM_flx_precip_sea  = ATM_flux_int ( ATM_precip * ATM_fsea )
+ATM_flx_emp         = ATM_flux_int ( ATM_emp)
+ATM_flx_wemp_ter    = ATM_flux_int ( ATM_wemp_ter )
+ATM_flx_wemp_oce    = ATM_flux_int ( ATM_wemp_oce )
+ATM_flx_wemp_lic    = ATM_flux_int ( ATM_wemp_lic )
+ATM_flx_wemp_sea    = ATM_flux_int ( ATM_wemp_sea )
+
+print ( '- Step 13', end='' )
 RUN_flx_coastal     = ONE_flux_int ( RUN_coastalflow)
 RUN_flx_river       = ONE_flux_int ( RUN_riverflow  )
@@ -950,20 +1125,17 @@
 RUN_flx_output      = ONE_flux_int ( RUN_output     )
 
-ATM_flx_emp   = ATM_flux_int (ATM_emp)
-ATM_flx_wbilo = ATM_flux_int (ATM_wbilo)
-
-RUN_flx_bil   = RUN_flx_input - RUN_flx_output
+print ( '- Step 14' )
+RUN_flx_bil    = RUN_flx_input   - RUN_flx_output
 RUN_flx_rivcoa = RUN_flx_coastal + RUN_flx_river
 
-prtFlux ('wbilo_oce     ', ATM_flx_oce, 'f' )
-prtFlux ('wbilo_oce     ', ATM_flx_oce, 'f' )          
-prtFlux ('wbilo_sic     ', ATM_flx_sic, 'f' )          
-prtFlux ('wbilo_sic+oce ', ATM_flx_sea, 'f' )          
-prtFlux ('wbilo_ter     ', ATM_flx_ter, 'f' )          
-prtFlux ('wbilo_lic     ', ATM_flx_lic, 'f' )          
+prtFlux ('wbilo_oce     ', ATM_flx_wbilo_oce  , 'f' )          
+prtFlux ('wbilo_sic     ', ATM_flx_wbilo_sic  , 'f' )          
+prtFlux ('wbilo_sic+oce ', ATM_flx_wbilo_sea  , 'f' )          
+prtFlux ('wbilo_ter     ', ATM_flx_wbilo_ter  , 'f' )          
+prtFlux ('wbilo_lic     ', ATM_flx_wbilo_lic  , 'f' )          
 prtFlux ('Sum wbilo_*   ', ATM_flx_wbilo      , 'f', True)  
 prtFlux ('E-P           ', ATM_flx_emp        , 'f', True)  
 prtFlux ('calving       ', ATM_flx_calving    , 'f' ) 
-prtFlux ('fqfonte       ', ATM_flx_qfonte     , 'f' )       
+prtFlux ('fqfonte       ', ATM_flx_fqfonte    , 'f' )       
 prtFlux ('precip        ', ATM_flx_precip     , 'f' )       
 prtFlux ('snowf         ', ATM_flx_snowf      , 'f' )        
@@ -982,25 +1154,61 @@
 prtFlux ('runoff lic    ', ATM_flx_runlic     , 'f' )   
 
-ATM_flx_budget = -ATM_flx_sea + ATM_flx_calving + ATM_flx_runlic #+ ATM_flx_qfonte + RUN_flx_river
+ATM_flx_budget = -ATM_flx_wbilo + ATM_flx_calving + ATM_flx_runlic #+ ATM_flx_fqfonte + RUN_flx_river
 echo ('')
-echo ('  Global        {:12.3e} kg | {:12.4f} Sv | {:12.4f} m '.format ( ATM_flx_budget , ATM_flx_budget / dtime_sec*1E-9, ATM_flx_budget /ATM_aire_sea_tot/ATM_rho ))
+#echo ('  Global        {:12.3e} kg | {:12.4f} Sv | {:12.4f} m '.format ( ATM_flx_budget , ATM_flx_budget / dtime_sec*1E-9, ATM_flx_budget /ATM_aire_sea_tot/ATM_rho ))
 
 #echo ('  E-P-R         {:12.3e} kg | {:12.4e} Sv | {:12.4f} m '.format ( ATM_flx_emp      , ATM_flx_emp      / dtime_sec*1E-6/ATM_rho, ATM_flx_emp      /ATM_aire_sea_tot/ATM_rho ))
+
+ATM_flx_toSRF = -ATM_flx_wbilo_ter
 
 echo (' ')
 echo ( '\n====================================================================================' )
 echo ( f'--  Atmosphere  -- {Title} ' )
-echo ( 'Mass begin = {:12.6e} kg | Mass end = {:12.6e} kg'.format (DYN_mas_wat_beg, DYN_mas_wat_end) )
-echo ( 'dmass (atm)  = {:12.3e} kg | {:12.4e} Sv | {:12.4f} mm/year '.format ( dDYN_mas_wat , kg2Sv(dDYN_mas_wat) , kg2myear(dDYN_mas_wat )*1000. ))
-echo ( 'Sum wbilo_*  = {:12.3e} kg | {:12.4e} Sv | {:12.4f} mm/year '.format ( ATM_flx_wbilo, kg2Sv(ATM_flx_wbilo), kg2myear(ATM_flx_wbilo )*1000. ))
-echo ( 'E-P          = {:12.3e} kg | {:12.4e} Sv | {:12.4f} mm/year '.format ( ATM_flx_emp  , kg2Sv(ATM_flx_emp ) , kg2myear(ATM_flx_emp  )*1000. ))
+echo ( f'Mass begin = {DYN_mas_wat_beg:12.6e} kg | Mass end = {DYN_mas_wat_end:12.6e} kg' )
+prtFlux ( 'dmass (atm)  = ', dDYN_mas_wat , 'e', True )
+prtFlux ( 'Sum wbilo_*  = ', ATM_flx_wbilo, 'e', True )
+prtFlux ( 'E-P          = ', ATM_flx_emp  , 'e', True )
 echo ( ' ' )
-prtFlux ( 'Perte eau atm ', ATM_flx_wbilo - dDYN_mas_wat, 'e', True )
-echo ( 'Perte eau atm = {:12.3e} (rel)  '.format ( (ATM_flx_wbilo - dDYN_mas_wat)/dDYN_mas_wat  ) )
+prtFlux ( 'Water loss atm', ATM_flx_wbilo - dDYN_mas_wat, 'f', True )
+echo ( 'Water loss atm = {:12.3e} (rel)  '.format ( (ATM_flx_wbilo - dDYN_mas_wat)/dDYN_mas_wat  ) )
 
 echo (' ')
-prtFlux ( 'Perte eau atm', ATM_flx_emp  - dDYN_mas_wat , 'e', True )
-echo ( 'Perte eau atm = {:12.3e} (rel)  '.format ( (ATM_flx_emp-dDYN_mas_wat)/dDYN_mas_wat  ) )
+prtFlux ( 'Water loss atm', ATM_flx_emp  - dDYN_mas_wat , 'f', True )
+echo ( 'Water loss atm = {:12.3e} (rel)  '.format ( (ATM_flx_emp-dDYN_mas_wat)/dDYN_mas_wat  ) )
 echo (' ')
+
+echo (' ')
+echo ( '\n====================================================================================' )
+
+ATM_flx_runofflic_lic = ATM_flux_int ( ATM_runofflic * ATM_flic )
+
+LIC_flx_budget1 = -ATM_flx_wemp_lic  - ATM_flx_calving - ATM_flx_fqfonte
+LIC_flx_budget2 = -ATM_flx_wbilo_lic - ATM_flx_calving - ATM_flx_fqfonte
+LIC_flx_budget3 = -ATM_flx_wbilo_lic - ATM_flx_runofflic_lic
+
+echo ( f'--  LIC  -- {Title} ' )
+echo ( f'Mass total   begin = {LIC_mas_wat_beg    :12.6e} kg | Mass end = {LIC_mas_wat_end    :12.6e} kg' )
+echo ( f'Mass snow    begin = {LIC_mas_sno_beg    :12.6e} kg | Mass end = {LIC_mas_sno_end    :12.6e} kg' )
+echo ( f'Mass qs      begin = {LIC_mas_qs_beg     :12.6e} kg | Mass end = {LIC_mas_qs_end     :12.6e} kg' )
+echo ( f'Mass runlic0 begin = {LIC_mas_runlic0_beg:12.6e} kg | Mass end = {LIC_mas_runlic0_end:12.6e} kg' )
+prtFlux ( 'dmass (LIC sno)       ', dLIC_mas_sno          , 'f', True, width=65 )
+prtFlux ( 'dmass (LIC qs)        ', dLIC_mas_qs           , 'e', True, width=65 )
+prtFlux ( 'dmass (LIC wat)       ', dLIC_mas_wat          , 'f', True, width=65 )
+prtFlux ( 'dmass (LIC runlic0)   ', dLIC_mas_runlic0      , 'e', True, width=65 )
+prtFlux ( 'dmass (LIC total)     ', dLIC_mas_wat          , 'e', True, width=65 )
+prtFlux ( 'LIC ATM_flx_wemp_lic  ', ATM_flx_wemp_lic      , 'f', True, width=65 )
+prtFlux ( 'LIC ATM_flx_fqfonte   ', ATM_flx_fqfonte       , 'f', True, width=65 )
+prtFlux ( 'LIC ATM_flx_calving   ', ATM_flx_calving       , 'f', True, width=65 )
+prtFlux ( 'LIC ATM_flx_runofflic ', ATM_flx_runofflic_lic , 'f', True, width=65 )
+prtFlux ( 'LIC fqfonte + calving ', ATM_flx_calving+ATM_flx_fqfonte , 'f', True, width=65 )
+prtFlux ( 'LIC fluxes 1 (wevap - precip*frac_lic  - fqcalving - fqfonte) ', LIC_flx_budget1              , 'f', True, width=65 )
+prtFlux ( 'LIC fluxes 2 (-wbilo_lic - fqcalving - fqfonte)               ', LIC_flx_budget2              , 'f', True, width=65 )
+prtFlux ( 'LIC fluxes 3 (-wbilo_lic - runofflic*frac_lic)                ', LIC_flx_budget3              , 'f', True, width=65 )
+prtFlux ( 'LIC error 1                                                   ', LIC_flx_budget1-dLIC_mas_wat , 'e', True, width=65 )
+prtFlux ( 'LIC error 2                                                   ', LIC_flx_budget2-dLIC_mas_wat , 'e', True, width=65 )
+prtFlux ( 'LIC error 3                                                   ', LIC_flx_budget3-dLIC_mas_wat , 'e', True, width=65 )
+echo ( 'LIC error (wevap - precip*frac_lic  - fqcalving - fqfonte)    = {:12.4e} (rel) '.format ( (LIC_flx_budget1-dLIC_mas_wat)/dLIC_mas_wat) )
+echo ( 'LIC error (-wbilo_lic - fqcalving - fqfonte)                  = {:12.4e} (rel) '.format ( (LIC_flx_budget2-dLIC_mas_wat)/dLIC_mas_wat) )
+echo ( 'LIC error (-wbilo_lic - runofflic*frac_lic)                   = {:12.4e} (rel) '.format ( (LIC_flx_budget3-dLIC_mas_wat)/dLIC_mas_wat) )
 
 echo ( '\n====================================================================================' )
@@ -1019,18 +1227,27 @@
 SRF_flx_all = SRF_flx_rain + SRF_flx_snowf - SRF_flx_evap - RUN_flx_runoff - RUN_flx_drainage
 
-prtFlux ('rain       ', SRF_flx_rain     , 'f' )
-prtFlux ('evap       ', SRF_flx_evap     , 'f' )
-prtFlux ('snowf      ', SRF_flx_snowf    , 'f' )
-prtFlux ('E-P        ', SRF_flx_emp      , 'f' )
-prtFlux ('subli      ', SRF_flx_subli    , 'f' )
-prtFlux ('transpir   ', SRF_flx_transpir , 'f' )
-prtFlux ('to routing ', RUN_flx_torouting, 'f' )
-prtFlux ('budget     ', SRF_flx_all      , 'f', True )
+prtFlux ('rain         ', SRF_flx_rain       , 'f' )
+prtFlux ('evap         ', SRF_flx_evap       , 'f' )
+prtFlux ('snowf        ', SRF_flx_snowf      , 'f' )
+prtFlux ('E-P          ', SRF_flx_emp        , 'f' )
+prtFlux ('subli        ', SRF_flx_subli      , 'f' )
+prtFlux ('transpir     ', SRF_flx_transpir   , 'f' )
+prtFlux ('to routing   ', RUN_flx_torouting  , 'f' )
+prtFlux ('budget       ', SRF_flx_all        , 'f', small=True )
 
 echo ( '\n------------------------------------------------------------------------------------' )
 echo ( 'Water content in surface ' )
-echo ( 'SRF_mas_wat_beg  = {:12.6e} kg | SRF_mas_wat_end  = {:12.6e} kg '.format (SRF_mas_wat_beg, SRF_mas_wat_end) )
-prtFlux ( 'dMass (water srf)', dSRF_mas_wat, 'e', True)
+echo ( f'SRF_mas_wat_beg  = {SRF_mas_wat_beg:12.6e} kg | SRF_mas_wat_end  = {SRF_mas_wat_end:12.6e} kg ' )
+prtFlux ( 'dMass (water srf)', dSRF_mas_wat, 'e', small=True)
+prtFlux ( 'Error            ',  SRF_flx_all-dSRF_mas_wat, 'e', small=True )
 echo ( 'dMass (water srf) = {:12.4e} (rel)   '.format ( (SRF_flx_all-dSRF_mas_wat)/dSRF_mas_wat) )
+
+echo ( '\n====================================================================================' )
+echo ( f'-- Check ATM vs. SRF -- {Title} ' )
+prtFlux ('E-P ATM       ', ATM_flx_wemp_ter   , 'f' )
+prtFlux ('wbilo ter     ', ATM_flx_wbilo_ter  , 'f' )
+prtFlux ('E-P SRF       ', SRF_flx_emp        , 'f' )
+prtFlux ('SRF/ATM error ', ATM_flx_wbilo_ter - SRF_flx_emp, 'e', True)
+echo ( 'SRF/ATM error {:12.3e} (rel)  '.format ( (ATM_flx_wbilo_ter - SRF_flx_emp)/SRF_flx_emp ) )
 
 echo ('')
